public class MagList
    {
    private Node start, now, end;
    
    public MagList ()
	{
	now = null;
	start = null;
	end = null;
	}
    
    public void add (String x, boolean s)
	{
	if (start == null)
	    {
	    start = new Node (x, s, null, null);
	    end = now = start;
	    }
	else
	    {
	    Node T = new Node (x, s, now.next, now);
	    now.next = T;
	    now = T;
	    if (now.next == null)
		end = T;
	    }
	}
    
    public boolean eol ()
	{
	return now == null;
	}
    
    public void gotoNext ()
	{
	now = now.next;
	}
    
    public void gotoLast ()
	{
	now = now.last;
	}
    
    public void reset ()
	{
	now = start;
	}
    
    public String getData ()
	{
	return now.data;
	}
    
    public boolean getStyle ()
	{
	return now.style;
	}
	
    private class Node 
	{
	String data;
	boolean style;
	Node next;
	Node last;
	
	Node (String d, boolean s, Node n, Node l)
	    {
	    data = d;
	    style = s;
	    next = n;
	    last = l;
	    }
	}
    }