import java.io.*;

public class ReadFile {
	private DataInputStream dis;
	private boolean fehler;
	
	public ReadFile(String path, String name) throws MyException {
		try {
			dis = new DataInputStream(new FileInputStream(new File(path, name)));
			fehler = false;
			}
		catch (Exception e) {
			fehler = true;
			throw new MyException ("Fehler beim ffnen: " + e.getMessage());
			}
		}
	
	public ReadFile(String pathname) throws MyException {
		try {
			dis = new DataInputStream(new FileInputStream(new File(pathname)));
			fehler = false;
			}
		catch (Exception e) {
			fehler = true;
			throw new MyException ("Fehler beim ffnen: " + e.getMessage());
			}
		}
	
	public String readLine() throws MyException {
		String s = null;
		if (fehler)
			return null;
		try {
			s = dis.readLine();
			}
		catch (IOException e) {
			throw new MyException ("Fehler beim Lesen: " + e.getMessage());
			}
		return s;
		}
	
	public void close() throws MyException {
		try {
			fehler = true;
			dis.close();
			}
		catch (IOException e) {
			throw new MyException ("Fehler beim Schlieen: " + e.getMessage());
			}
		}
	}
